# include <stdio.h>
# include <string.h>
# define GRAN 1000
# define SHIRINA 10280
# define VISOTA 120

char red[SHIRINA*VISOTA*3];//3072000=1280*800*3
char stroka[54];

struct point
{
	char red;
	char green;
	char blue;
};

struct point massiv[SHIRINA][VISOTA];

int abs(int f)
{
	if (f<0)
		f=-f;
	return f;
}

double max(double a, double b)
{
	if(a>b)
	{
		return a;
	}
	else return b;
}

double min(double a, double b)
{
	if(a>b)
	{
		return b;
	}
	else return a;
}
//-------------------------------------------------------------------------------------------------------------------------------------------
void otrezok(struct point mas[SHIRINA][VISOTA],int x1,int y1,int x2,int y2,struct point color)
{
	//--------------------   ------------------------------------------------------------------------
	double x1q,y1q,x2q,y2q;

	if(x1>x2)
	{
		x1q=x1+0.5;
		x2q=x2-0.5;
	}
	else
		if(x2>x1)
		{
			x1q=x1-0.5;
			x2q=x2+0.5;
		}
		else
		{
			x1q=x1-0.5;
			x2q=x2+0.5;
		}

	if(y1>y2)
	{
		y1q=y1+0.5;
		y2q=y2-0.5;
	}
	else
		if(y2>y1)
		{
			y1q=y1-0.5;
			y2q=y2+0.5;
		}
		else
		{
			y1q=y1-0.5;
			y2q=y2+0.5;
		}
	//---------------   -----------------------------------------------

	double a,b,c=0;
	int aa,bb;

	//for(bb=0;bb<VISOTA;bb++)
	//	for(aa=0;aa<SHIRINA;aa++)
	for(bb=min(y1q,y2q);bb<max(y1q,y2q);bb++)
		for(aa=min(x1q,x2q);aa<max(x1q,x2q);aa++)
		{
			//printf("Hello\n");
			//if(min(x1q,x2q)<=aa && aa<=max(x1q,x2q) && min(y1q,y2q)<=bb && bb<=max(y1q,y2q))
			{
				c=0;

				a=aa-0.5;
				b=bb-0.5;
				if( a*(y2q-y1q)+b*(x1q-x2q)+x1q*(y1q-y2q)+y1q*(x2q-x1q)>0 )
					{
						c++;
					}
				else
					if( a*(y2q-y1q)+b*(x1q-x2q)+x1q*(y1q-y2q)+y1q*(x2q-x1q)<0 )
					c--;

				a=aa+0.5;
				b=bb+0.5;
				if( a*(y2q-y1q)+b*(x1q-x2q)+x1q*(y1q-y2q)+y1q*(x2q-x1q)>0 )
					{
						c++;
					}
				else
					if( a*(y2q-y1q)+b*(x1q-x2q)+x1q*(y1q-y2q)+y1q*(x2q-x1q)<0 )
					c--;

				a=aa+0.5;
				b=bb-0.5;
				if( a*(y2q-y1q)+b*(x1q-x2q)+x1q*(y1q-y2q)+y1q*(x2q-x1q)>0 )
					{
						c++;
					}
				else
					if( a*(y2q-y1q)+b*(x1q-x2q)+x1q*(y1q-y2q)+y1q*(x2q-x1q)<0 )
					c--;

				a=aa-0.5;
				b=bb+0.5;
				if( a*(y2q-y1q)+b*(x1q-x2q)+x1q*(y1q-y2q)+y1q*(x2q-x1q)>0 )
					{
						c++;
					}
				else
					if( a*(y2q-y1q)+b*(x1q-x2q)+x1q*(y1q-y2q)+y1q*(x2q-x1q)<0 )
					c--;

				if(abs(c)!=4)
				{
					//printf("hello aa=%d bb=%d\n",aa,bb);
					mas[aa][bb].red=color.red;
					mas[aa][bb].green=color.green;
					mas[aa][bb].blue=color.blue;
				}
				if(abs(c)==3)
				{
					//printf("hello aa=%d bb=%d\n",aa,bb);
					mas[aa][bb].red=color.red+80;
					mas[aa][bb].green=color.green+80;
					mas[aa][bb].blue=color.blue+80;
				}

				//printf("abs(c)=%d\n",abs(c));
			}
		}
			//  
			//if(x1>x2)
			//	aa--;
			//else
			//	if(x2>x1)
			//	aa++;
		//}
		//if(y1>y2)
		//	bb--;
		//else
		//	if(y2>y1)
		//	bb++;
	//}

}

//--------------------------------------------------------------------------------------------------------------------------------------------
//--------------------------------------------------------------------------------------------------------------------------------------------
//--------------------------------------------------------------------------------------------------------------------------------------------


void pryamaya(struct point mas[SHIRINA][VISOTA],int x1,int y1,int x2,int y2,struct point color)
{
	//--------------------   ------------------------------------------------------------------------
	double x1q,y1q,x2q,y2q;

	if(x1>x2)
	{
		x1q=x1+0.5;
		x2q=x2-0.5;
	}
	else
		if(x2>x1)
		{
			x1q=x1-0.5;
			x2q=x2+0.5;
		}
		else
		{
			x1q=x1;
			x2q=x2;
		}

	if(y1>y2)
	{
		y1q=y1+0.5;
		y2q=y2-0.5;
	}
	else
		if(y2>y1)
		{
			y1q=y1-0.5;
			y2q=y2+0.5;
		}
		else
		{
			y1q=y1;
			y2q=y2;
		}
	//---------------   -----------------------------------------------

	double a,b,c=0;
	int aa,bb;

	//aa=x1;
	//bb=y1;

	//while(bb!=y2)
	//{
	//	while(c!=4)
	//	{
	for(bb=0;bb<VISOTA;bb++)
		for(aa=0;aa<SHIRINA;aa++)
		{
			c=0;

			a=aa-0.5;
			b=bb-0.5;
			if( a*(y2q-y1q)+b*(x1q-x2q)+x1q*(y1q-y2q)+y1q*(x2q-x1q)>0 )
				{
					c++;
				}
			else
				if( a*(y2q-y1q)+b*(x1q-x2q)+x1q*(y1q-y2q)+y1q*(x2q-x1q)<0 )
				c--;

			a=aa+0.5;
			b=bb+0.5;
			if( a*(y2q-y1q)+b*(x1q-x2q)+x1q*(y1q-y2q)+y1q*(x2q-x1q)>0 )
				{
					c++;
				}
			else
				if( a*(y2q-y1q)+b*(x1q-x2q)+x1q*(y1q-y2q)+y1q*(x2q-x1q)<0 )
				c--;

			a=aa+0.5;
			b=bb-0.5;
			if( a*(y2q-y1q)+b*(x1q-x2q)+x1q*(y1q-y2q)+y1q*(x2q-x1q)>0 )
				{
					c++;
				}
			else
				if( a*(y2q-y1q)+b*(x1q-x2q)+x1q*(y1q-y2q)+y1q*(x2q-x1q)<0 )
				c--;

			a=aa-0.5;
			b=bb+0.5;
			if( a*(y2q-y1q)+b*(x1q-x2q)+x1q*(y1q-y2q)+y1q*(x2q-x1q)>0 )
				{
					c++;
				}
			else
				if( a*(y2q-y1q)+b*(x1q-x2q)+x1q*(y1q-y2q)+y1q*(x2q-x1q)<0 )
				c--;

			if(abs(c)!=4)
			{
				printf("hello aa=%d bb=%d\n",aa,bb);
				mas[aa][bb].red=color.red;
				mas[aa][bb].green=color.green;
				mas[aa][bb].blue=color.blue;
			}
			if(abs(c)==3)
			{
				printf("hello aa=%d bb=%d\n",aa,bb);
				mas[aa][bb].red=color.red+100;
				mas[aa][bb].green=color.green+100;
				mas[aa][bb].blue=color.blue+100;
			}

		}
			//  
			//if(x1>x2)
			//	aa--;
			//else
			//	if(x2>x1)
			//	aa++;
		//}
		//if(y1>y2)
		//	bb--;
		//else
		//	if(y2>y1)
		//	bb++;
	//}

}
//---------------------------------------------------------------------------------------------------------------------------------------

int main()
{
	//-------------- ---------------------------------------------------------------------------
	int deliteli[GRAN];

	int r,r1,r2;
	for(r=0;r<GRAN;++r)
	{
		deliteli[r]=0;
		r1=r;
		r2=2;
		while(r1>1)
		{
			while(r1%r2==0)
			{
				r1/=r2;
				deliteli[r]++;
			}
			r2++;
		}
		//printf("%d has %d divisors\n",r,deliteli[r]);
	}
	//------------------------------------------------------------------------------------------------------------

	//memset(red,255,SHIRINA*VISOTA*3);//string.h   3072000   red 

	//----   -----------------------------------------------------------------------
	for(r2=0;r2<VISOTA;r2++)
		for(r1=0;r1<SHIRINA;r1++)
		{
			massiv[r1][r2].red=255;
			massiv[r1][r2].green=255;
			massiv[r1][r2].blue=255;
		}
	//-----------------------------------------------------------------------------------------------------

	struct point cvet;
	cvet.red=0;
	cvet.green=0;
	cvet.blue=0;

	//otrezok(massiv,100,100,350,100,cvet);
	//otrezok(massiv,10,160,150,250,cvet);
	//otrezok(massiv,50,260,150,250,cvet);
	//otrezok(massiv,50,50,550,550,cvet);

	//----- -----------------------------------------------------------------------------------------
double mashtab=10;
int i;
for(i=0;i<GRAN-1;++i)
{
	otrezok(massiv,i*mashtab,deliteli[i]*mashtab,(i+1)*mashtab,deliteli[i+1]*mashtab,cvet);
}

	//-----     red-----------------------------------------------------------------------
	r=0;
	for(r2=0;r2<VISOTA;r2++)
		for(r1=0;r1<SHIRINA;r1++)
		{
			red[r]=massiv[r1][r2].red;
			red[r+1]=massiv[r1][r2].green;
			red[r+2]=massiv[r1][r2].blue;
			r+=3;
		}
		printf("%d\n",r);
	//--------------------------------------------------------------------------------------------------------------------------------------
	FILE *fp,*fp2;
	fp=fopen("test.bmp","rb");
	fp2=fopen("out.bmp","wb");

	fread(stroka, sizeof(char),54,fp);
	fwrite(stroka, sizeof(char),54,fp2);
	fwrite(red,sizeof(char),SHIRINA*VISOTA*3,fp2);

	fclose(fp); fclose(fp2);
}
